<?php
// *******************************************************************
// Title          udde Instant Messages (uddeIM)
// Description    Instant Messages System for Mambo 4.5 / Joomla 1.0 / Joomla 1.5
// Author          2007-2008 Stephan Slabihoud,  2006 Benjamin Zweifel
// License        This is free software and you may redistribute it under the GPL.
//                uddeIM comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
// *******************************************************************

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function uddeIMshowTrashCan($myself, $item_id, $limit, $limitstart, $cryptpass, $config) {
	global $database;
	global $uddeicons_onlinepic, $uddeicons_offlinepic, $uddeicons_readpic, $uddeicons_unreadpic, $pathtosite, $pathtouser;

	$my_gid = uddeIMgetGID((int)$myself);

	if( ($config->trashrestriction==0) ||
	    ($config->trashrestriction==1 && in_array($my_gid,array(19,20,21,23,24,25))) || 
	    ($config->trashrestriction==2 && in_array($my_gid,array(24,25))) ) {
		// ok trashcan enabled
	} else {
		$mosmsg=_UDDEADM_NOTRASHACCESS_NOT;
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		if (stristr($redirecturl, "trashcan")) {
			uddeJSEFredirect("index.php?option=com_uddeim&Itemid=".$item_id, $mosmsg);
		}
		uddeJredirect($redirecturl, $mosmsg);
	}

	$rightnow=uddetime();
	$offset=((float)$config->TrashLifespan) * 86400;
	$timeframe=$rightnow-$offset;

	// how many messages total?
	//	$sql="SELECT count(id) FROM #__uddeim WHERE (totrashdate>=".$timeframe." AND toid=".(int)$myself." AND totrash=1) OR (totrashdateoutbox>=".$timeframe." AND fromid=".(int)$myself." AND totrashoutbox=1)";
	// dont count messages that are "copy to me" messages and sender has already trashed the message (totrashoutbox=1 and fromid=toid)

	// !!! systemmessages from me to others should not be shown here when  totrashoutbox=1 and totrashdateoutbox=valid (==add: AND ((systemmessage IS NULL) OR (systemmessage='')))

//	$sql="SELECT count(a.id) FROM #__uddeim AS a, #__users AS b WHERE (totrashdate>=".$timeframe." AND a.toid=".(int)$myself." AND a.totrash=1 AND a.fromid=b.id) OR (totrashdateoutbox>=".$timeframe." AND a.fromid=".(int)$myself." AND a.totrashoutbox=1 AND a.toid=b.id AND a.toid<>a.fromid AND ((systemmessage IS NULL) OR (systemmessage='')))";

	$sql = "SELECT count(a.id)
				FROM (#__uddeim AS a LEFT JOIN #__users AS ufrom ON a.fromid = ufrom.id) 
									 LEFT JOIN #__users AS uto   ON a.toid   = uto.id
				WHERE (totrashdate       >= ".$timeframe." AND a.totrash=1       AND a.toid  =".(int)$myself.") 
				   OR (totrashdateoutbox >= ".$timeframe." AND a.totrashoutbox=1 AND a.fromid=".(int)$myself." AND a.toid<>a.fromid AND ((systemmessage IS NULL) OR (systemmessage='')))"; 
	$database->setQuery($sql);
	$total=$database->loadResult();

	// now load messages as required
	if(!$limitstart) {
		$limitstart=0;
	}
	if(!$limit) {
		$limit=$config->perpage;
	}

	if ($limitstart>=$total)
		$limitstart=max(0,$limitstart - $limit);

	// dont select messages that are "copy to me" messages and sender has already trashed the message (totrashoutbox=1 and fromid=toid)
//	if ($config->pubfrontend)
//		$sql = "(SELECT a.*, 'Public User' AS fromname FROM #__uddeim AS a WHERE (totrashdate>=".$timeframe." AND a.toid=".(int)$myself." AND a.totrash=1 AND a.fromid=0) OR (totrashdateoutbox>=".$timeframe." AND a.fromid=".(int)$myself." AND a.totrashoutbox=1 AND a.toid=0 AND a.toid<>a.fromid AND ((systemmessage IS NULL) OR (systemmessage='')))) UNION "
//			 . "(SELECT a.*, b.".($config->realnames ? "name" : "username")." AS fromname FROM #__uddeim AS a, #__users AS b WHERE (totrashdate>=".$timeframe." AND a.toid=".(int)$myself." AND a.totrash=1 AND a.fromid=b.id) OR (totrashdateoutbox>=".$timeframe." AND a.fromid=".(int)$myself." AND a.totrashoutbox=1 AND a.toid=b.id AND a.toid<>a.fromid AND ((systemmessage IS NULL) OR (systemmessage='')))) ORDER BY totrashdate, totrashdateoutbox DESC LIMIT ".(int)$limitstart.", ".(int)$limit;
//	else
//		$sql="SELECT a.*, b.".($config->realnames ? "name" : "username")." AS fromname FROM #__uddeim AS a, #__users AS b WHERE (totrashdate>=".$timeframe." AND a.toid=".(int)$myself." AND a.totrash=1 AND a.fromid=b.id) OR (totrashdateoutbox>=".$timeframe." AND a.fromid=".(int)$myself." AND a.totrashoutbox=1 AND a.toid=b.id AND a.toid<>a.fromid AND ((systemmessage IS NULL) OR (systemmessage=''))) ORDER BY totrashdate, totrashdateoutbox DESC LIMIT ".(int)$limitstart.", ".(int)$limit;

	$sql = "SELECT a.*, ufrom.".($config->pubrealnames ? "name" : "username")." AS fromname, 
						  uto.".($config->pubrealnames ? "name" : "username")." AS toname
				FROM (#__uddeim AS a LEFT JOIN #__users AS ufrom ON a.fromid = ufrom.id) 
									 LEFT JOIN #__users AS uto   ON a.toid   = uto.id
				WHERE (totrashdate       >= ".$timeframe." AND a.totrash=1       AND a.toid  =".(int)$myself.") 
				   OR (totrashdateoutbox >= ".$timeframe." AND a.totrashoutbox=1 AND a.fromid=".(int)$myself." AND a.toid<>a.fromid AND ((systemmessage IS NULL) OR (systemmessage=''))) 
				ORDER BY IF(totrashdate,totrashdate,totrashdateoutbox) DESC LIMIT ".(int)$limitstart.", ".(int)$limit;

	$database->setQuery($sql);
	$allmessages=$database->loadObjectList();

	// write the uddeim menu
	print_uddemenu($myself, 'trashcan', $item_id, $config);
	echo "<div id='uddeim-m'>\n";

	// if no messages:
	if(count($allmessages)<1) { // no messages to list
		echo "<div id='uddeim-overview'><p>"._UDDEIM_NOMESSAGES_TRASHCAN."</p>\n</div>\n";
		// and close the HTML output and return
		echo "</div>\n<div id='uddeim-bottomborder'>".contentBottomborder($myself, $item_id, 'standard', 'none', $config)."</div>\n";
		return;
	}

	// now open the inbox container and table; write table headings
	echo "<div id='uddeim-overview'>";
	echo "<table cellpadding='7' width='100%'>";
	echo "\n\n\t<tr><th class='sectiontableheader'>&nbsp;</th><th class='sectiontableheader'>"._UDDEIM_FROM." / "._UDDEIM_TO."</th><th class='sectiontableheader'>"._UDDEIM_MESSAGE."</th><th class='sectiontableheader'>"._UDDEIM_DELETED."</th><th class='sectiontableheader'>&nbsp;</th></tr>";

	$i=1;
	// now write the list
	foreach($allmessages as $themessage) {

		if($themessage->toread) {
			$readcell=$uddeicons_readpic;
		} else {
			$readcell=$uddeicons_unreadpic;
		}

		$themarker = "";
		$theuser = 0;
		$datumcell = "";
		if ($myself==$themessage->toid && $myself!=$themessage->fromid) {
			// Msg sent to me, sender is someone else, so user is in "fromid"
			$themarker = "&lt;";
			$theuser = $themessage->fromid;
			$datumcell=uddeDate($themessage->totrashdate, $config);
// $displayname = $themessage->fromname;
			$displayname = uddeIMevaluateUsername($themessage->fromname, $themessage->fromid, $themessage->publicname);
		} elseif ($myself==$themessage->fromid && $myself!=$themessage->toid) {
			// Msg sent by me, receiver is someone else, so user is in "toid"
			$themarker = "&gt;";
			$theuser = $themessage->toid;
			$datumcell=uddeDate($themessage->totrashdateoutbox, $config);
// $displayname = $themessage->toname;
			$displayname = uddeIMevaluateUsername($themessage->toname, $themessage->toid, $themessage->publicname);
		} else {	// this case appears when a copy to me message has been trashed my myself
			// totrashoutbox=1 messages (sender has trashed are not selected in the SQL statement, so they do not appear here
			// totrash=1 messages has been trashed by myself, so I show them in the trashcan
			$themarker = "&lt;";	// the message has been send to me (we could also reorder the if-clause and catch this case with "$myself==$themessage->toid" but maybe I change the marker sometime)
			$theuser = $themessage->fromid;
			$datumcell=uddeDate($themessage->totrashdate, $config);
$displayname = $themessage->fromname;
		}

//		if ( (!$displayname || $displayname==NULL) && !$theuser)
//			$displayname = _UDDEIM_PUBLICUSER;
//		elseif ($displayname==NULL)
//			$displayname = _UDDEIM_DELETEDUSER;

// not necessary since I have to correct entries in the SQL statement
//		if($config->realnames) {
//			$sql="SELECT name AS fromname FROM #__users WHERE id=".(int)$theuser;
//		} else {
//			$sql="SELECT username AS fromname FROM #__users WHERE id=".(int)$theuser;
//		}
//		$database->setQuery($sql);
//		$displayname=$database->loadResult();

		// systemmessage = "an XXX XXXX"
		$personalsys=0;
		if($themessage->systemmessage==$displayname && $myself==$themessage->toid) {
			$personalsys=1;
		}
		if($themessage->systemmessage && $myself==$themessage->toid) {
			$displayname=$themessage->systemmessage;
		}

		$fromcell=$themarker." ".$displayname;
		if ($theuser) {
			if(($config->showcblink && !$themessage->systemmessage) || ($config->showcblink && $personalsys)) {
				if($config->getpiclink) {
					$fromcell=getPicLink($theuser, $themarker." ".$displayname, $config);
				} else {
					$fromcell="<a href='".sefRelToAbs("index.php?option=com_comprofiler&task=userProfile&user=".$theuser)."'>".$themarker." ".$displayname."</a>";
				}
			}

			// is this user currently online?
			if (($config->showonline && !$themessage->systemmessage) || ($config->showonline && $personalsys)) {
				$sql="SELECT count(userid) FROM #__session WHERE userid=".(int)$theuser;
				$database->setQuery($sql);
				$isonline=$database->loadResult();
				if($isonline) {
					$fromcell.="&nbsp;".$uddeicons_onlinepic;
				} else {
					$fromcell.="&nbsp;".$uddeicons_offlinepic;
				}
			}
		}

		// CRYPT
		$cm = getUddeIMmessage($themessage->message, $cryptpass, $themessage->cryptmode, $themessage->crypthash, $config->cryptkey);

		$teasermessage=$cm;
		// if it is a system message or bb codes allowed, parse BB codes
		if ($themessage->systemmessage || $config->allowbb)
			$teasermessage=bbcode_strip($teasermessage);

		$teasermessage=uddeIMteaser(stripslashes($teasermessage), $config->firstwordsinbox, $config->quotedivider, $config->languagecharset);
		$teasermessage=htmlspecialchars($teasermessage, ENT_QUOTES, $config->charset);
		$teasermessage=str_replace("&amp;#", "&#", $teasermessage);
		$safemessage=htmlspecialchars(stripslashes($cm), ENT_QUOTES, $config->charset);

		$messagecell=$teasermessage;

		if($config->actionicons) {
			$deletecell="<a href='".sefRelToAbs("index.php?option=com_uddeim&task=restore&Itemid=".$item_id."&limit=".$limit."&limitstart=".$limitstart."&messageid=".$themessage->id)."'><img src='".$pathtosite."/components/com_uddeim/templates/".$config->templatedir."/images/recycle.gif' alt='"._UDDEIM_RESTORE."' title='"._UDDEIM_RESTORE."' /></a>";
		} else {
			$deletecell="<a href='".sefRelToAbs("index.php?option=com_uddeim&task=restore&Itemid=".$item_id."&limit=".$limit."&limitstart=".$limitstart."&messageid=".$themessage->id)."'>"._UDDEIM_RESTORE."</a>";
		}

		echo "\n\t<tr class='sectiontableentry".$i."'>";
		echo "\n\t\t<td style='width:32px; text-align:center; vertical-align:middle'>".$readcell."</td>";
		$st=getStyleForThumb($config);
		echo "\n\t\t<td ".$st.">".$fromcell."</td>";
		echo "\n\t\t<td>".$messagecell."</td>";
		echo "\n\t\t<td>".$datumcell."</td>";
		if($config->actionicons) {
			echo "\n\t\t<td style='width:32px; text-align:center; vertical-align:middle'>".$deletecell."</td>";
		} else {
			echo "\n\t\t<td class='pathway'>".$deletecell."</td>";
		}
		echo "</tr>";

		$i++;
		if ($i>2) {
			$i=1;
		}
	}

	// now close inbox table and container
	echo "\n</table></div>\n";

	// write the inbox navigation links
	$pageNav = new mosPageNav($total, $limitstart, $limit);
	$referlink = "index.php?option=com_uddeim&task=trashcan&Itemid=".$item_id;
	if($total>$limit) {
		$shownav = $pageNav->writePagesLinks($referlink);
		$shownav = uddeIMarrowReplace($shownav, $config->templatedir, $pathtouser);
		echo "<div id='uddeim-pagenav'>".$shownav."<br />";
		echo "[<a href='".sefRelToAbs("index.php?option=com_uddeim&task=trashcan&Itemid=".$item_id."&limitstart=0&limit=".$total)."'>"._UDDEIM_SHOWALL."</a>]";
		echo "</div>\n";
	}

	$keephours=((float)$config->TrashLifespan) * 24;
	echo "<div id='uddeim-bottomlines'>";
	if ($config->TrashLifespanNote)
		echo "<p>"._UDDEIM_TRASHCAN_INFO_1.$keephours._UDDEIM_TRASHCAN_INFO_2."</p>";
	echo "</div>\n";
	echo "</div>\n<div id='uddeim-bottomborder'>".contentBottomborder($myself, $item_id, 'standard', 'none', $config)."</div>\n";
}

// *****************************************************************************************

function uddeIMrestoreMessage($myself, $messageid, $limit, $limitstart, $item_id, $config) {
	global $database;

	$my_gid = uddeIMgetGID((int)$myself);

	if( ($config->trashrestriction==0) ||
	    ($config->trashrestriction==1 && in_array($my_gid,array(19,20,21,23,24,25))) || 
	    ($config->trashrestriction==2 && in_array($my_gid,array(24,25))) ) {
		// ok trashcan enabled
	} else {
		$mosmsg=_UDDEADM_NOTRASHACCESS_NOT;
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		if (stristr($redirecturl, "trashcan")) {
			uddeJSEFredirect("index.php?option=com_uddeim&Itemid=".$item_id, $mosmsg);
		}
		uddeJredirect($redirecturl, $mosmsg);
	}

	// to do: show error message when trying to restore message that has been deleted or is no longer available
	// this is a workaround for now: debug
	$sql="SELECT count(id) FROM #__uddeim WHERE id=".(int)$messageid;
	$database->setQuery($sql);
	$zaehler=$database->loadResult();
	if ((int)$zaehler<1) {
		$mosmsg = _UDDEIM_CANTRESTORE;
		uddeJSEFredirect("index.php?option=com_uddeim&task=trashcan&Itemid=".$item_id."&limit=".$limit."&limitstart=".$limitstart, $mosmsg);
		return;
	}

	// end of workaround
	// count from database all messages I saved. if greater than max, don't allow. warning text.

	$sql="SELECT count(id) FROM #__uddeim WHERE (toid=".(int)$myself." AND id=".(int)$messageid." AND archived=1 AND totrash=1) OR (fromid=".(int)$myself." AND id=".(int)$messageid." AND archived=1 AND totrashoutbox=1)";
	$database->setQuery($sql);
	$isinarchive=$database->loadResult();

	// if not allowarchive: send back where came from
	if(!$config->allowarchive && $isinarchive) {
		$mosmsg = _UDDEIM_ARCHIVENOTENABLED;
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		uddeJredirect($redirecturl, $mosmsg);
	}

	$arcsql=" AND archived=1";
	if ($config->inboxlimit) {
		$arcsql="";
	}
	$sql="SELECT count(id) FROM #__uddeim WHERE (toid=".((int)$myself).$arcsql." AND totrash=0) OR (fromid=".((int)$myself).$arcsql." AND totrashoutbox=0)";
	$database->setQuery($sql);
	$inarchive=$database->loadResult();

	// if ($inarchive >= $config->maxarchive && $my_gid<24) { // JACL support
	if ($inarchive >= $config->maxarchive && $my_gid!=24 && $my_gid!=25) {
		echo "<p>"._UDDEIM_ARC_SAVED_1.$inarchive._UDDEIM_ARC_SAVED_2."</p>\n";
		echo "<p>"._UDDEIM_ARC_SAVED_3."</p>\n";
		$mosmsg = _UDDEIM_LIMITREACHED;
		$redirecturl=mosGetParam( $_SERVER, 'HTTP_REFERER', null );
		uddeJredirect($redirecturl, $mosmsg);
	}

	$sql="SELECT totrash FROM #__uddeim WHERE toid=".(int)$myself." AND id=".(int)$messageid." AND totrash=1";
	$database->setQuery($sql);
	$totrash=$database->loadResult();

	$sql="SELECT totrashoutbox FROM #__uddeim WHERE fromid=".(int)$myself." AND id=".(int)$messageid." AND totrashoutbox=1";
	$database->setQuery($sql);
	$totrashoutbox=$database->loadResult();

	if($totrash) {
		$sql="UPDATE #__uddeim SET totrash=0, totrashdate=NULL WHERE toid=".(int)$myself." AND id=".(int)$messageid;
	} else if ($totrashoutbox) {
		$sql="UPDATE #__uddeim SET totrashoutbox=0, totrashdateoutbox=NULL WHERE fromid=".(int)$myself." AND id=".(int)$messageid;
	}

	$database->setQuery($sql);
	$numberofrows=$database->query();
	if (!$database->query()) {
		die("SQL error when attempting to restore a message" . $database->stderr(true));
	}

	// if archived then restore back to archive
	uddeJSEFredirect("index.php?option=com_uddeim&task=trashcan&Itemid=".$item_id."&limit=".$limit."&limitstart=".$limitstart);
}
